<html>
<head>
<title>Ogre::Pool&lt; T &gt; Class Template Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1Pool.html">Pool</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::Pool&lt; T &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__General.html">General</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::Pool" -->
<p>Template class describing a simple pool of items.  
 <a href="classOgre_1_1Pool.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreCommon_8h_source.html">OgreCommon.h</a>&gt;</code></p>

<p><a href="classOgre_1_1Pool-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Pool.html#a7bd667e735a8fdaf2e7017d436ba75a6">Pool</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Pool.html#a4fb09f4b25feb32de79b6f578359aab1">~Pool</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual std::pair&lt; bool, T &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Pool.html#a3151e6614c063eeae4bf7d95a9fbbbcb">removeItem</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the next item from the pool.  <a href="#a3151e6614c063eeae4bf7d95a9fbbbcb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Pool.html#abafd7c72963d86ef829c0373fe50aa7f">addItem</a> (const T &amp;i)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a new item to the pool.  <a href="#abafd7c72963d86ef829c0373fe50aa7f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Pool.html#af399adb462aa706c25e1e961cdfb5a1e">clear</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Clear the pool.  <a href="#af399adb462aa706c25e1e961cdfb5a1e"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1list.html">list</a>&lt; T &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Pool.html#a22614f3605b9a41e48143b472bf0bf57">ItemList</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Pool.html#a22614f3605b9a41e48143b472bf0bf57">ItemList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Pool.html#a90f343f0e581445b63f9319884730e12">mItems</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename T&gt;<br/>
class Ogre::Pool&lt; T &gt;</h3>

<p>Template class describing a simple pool of items. </p>

<p>Definition at line <a class="el" href="OgreCommon_8h_source.html#l00819">819</a> of file <a class="el" href="OgreCommon_8h_source.html">OgreCommon.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a22614f3605b9a41e48143b472bf0bf57"></a><!-- doxytag: member="Ogre::Pool::ItemList" ref="a22614f3605b9a41e48143b472bf0bf57" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1list.html">list</a>&lt;T&gt;::type <a class="el" href="classOgre_1_1Pool.html">Ogre::Pool</a>&lt; T &gt;::<a class="el" href="classOgre_1_1Pool.html#a22614f3605b9a41e48143b472bf0bf57">ItemList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreCommon_8h_source.html#l00822">822</a> of file <a class="el" href="OgreCommon_8h_source.html">OgreCommon.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a7bd667e735a8fdaf2e7017d436ba75a6"></a><!-- doxytag: member="Ogre::Pool::Pool" ref="a7bd667e735a8fdaf2e7017d436ba75a6" args="()" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Pool.html">Ogre::Pool</a>&lt; T &gt;::<a class="el" href="classOgre_1_1Pool.html">Pool</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreCommon_8h_source.html#l00826">826</a> of file <a class="el" href="OgreCommon_8h_source.html">OgreCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4fb09f4b25feb32de79b6f578359aab1"></a><!-- doxytag: member="Ogre::Pool::~Pool" ref="a4fb09f4b25feb32de79b6f578359aab1" args="()" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1Pool.html">Ogre::Pool</a>&lt; T &gt;::~<a class="el" href="classOgre_1_1Pool.html">Pool</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreCommon_8h_source.html#l00827">827</a> of file <a class="el" href="OgreCommon_8h_source.html">OgreCommon.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="abafd7c72963d86ef829c0373fe50aa7f"></a><!-- doxytag: member="Ogre::Pool::addItem" ref="abafd7c72963d86ef829c0373fe50aa7f" args="(const T &amp;i)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1Pool.html">Ogre::Pool</a>&lt; T &gt;::<a class="el" href="classOgre_1_1Pool.html#abafd7c72963d86ef829c0373fe50aa7f">addItem</a> </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>i</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a new item to the pool. </p>

<p>Definition at line <a class="el" href="OgreCommon_8h_source.html#l00851">851</a> of file <a class="el" href="OgreCommon_8h_source.html">OgreCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="af399adb462aa706c25e1e961cdfb5a1e"></a><!-- doxytag: member="Ogre::Pool::clear" ref="af399adb462aa706c25e1e961cdfb5a1e" args="()" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1Pool.html">Ogre::Pool</a>&lt; T &gt;::<a class="el" href="classOgre_1_1Pool.html#af399adb462aa706c25e1e961cdfb5a1e">clear</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Clear the pool. </p>

<p>Reimplemented in <a class="el" href="classOgre_1_1ResourceManager_1_1ResourcePool.html#a9009c4131abf1318693a01474755850f">Ogre::ResourceManager::ResourcePool</a>.</p>

<p>Definition at line <a class="el" href="OgreCommon_8h_source.html#l00857">857</a> of file <a class="el" href="OgreCommon_8h_source.html">OgreCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3151e6614c063eeae4bf7d95a9fbbbcb"></a><!-- doxytag: member="Ogre::Pool::removeItem" ref="a3151e6614c063eeae4bf7d95a9fbbbcb" args="()" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual std::pair&lt;bool, T&gt; <a class="el" href="classOgre_1_1Pool.html">Ogre::Pool</a>&lt; T &gt;::<a class="el" href="classOgre_1_1Pool.html#a3151e6614c063eeae4bf7d95a9fbbbcb">removeItem</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the next item from the pool. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>pair indicating whether there was a free item, and the item if so </dd></dl>

<p>Definition at line <a class="el" href="OgreCommon_8h_source.html#l00832">832</a> of file <a class="el" href="OgreCommon_8h_source.html">OgreCommon.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a90f343f0e581445b63f9319884730e12"></a><!-- doxytag: member="Ogre::Pool::mItems" ref="a90f343f0e581445b63f9319884730e12" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Pool.html#a22614f3605b9a41e48143b472bf0bf57">ItemList</a> <a class="el" href="classOgre_1_1Pool.html">Ogre::Pool</a>&lt; T &gt;::<a class="el" href="classOgre_1_1Pool.html#a90f343f0e581445b63f9319884730e12">mItems</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreCommon_8h_source.html#l00823">823</a> of file <a class="el" href="OgreCommon_8h_source.html">OgreCommon.h</a>.</p>

<p>Referenced by <a class="el" href="OgreCommon_8h_source.html#l00851">Ogre::Pool&lt; ResourcePtr &gt;::addItem()</a>, <a class="el" href="OgreCommon_8h_source.html#l00857">Ogre::Pool&lt; ResourcePtr &gt;::clear()</a>, and <a class="el" href="OgreCommon_8h_source.html#l00832">Ogre::Pool&lt; ResourcePtr &gt;::removeItem()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreCommon_8h_source.html">OgreCommon.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:55
</p>
</body>
</html>
